// Original code by TAKAHASHI Shuhei <pcb@pcbsoft.net>
// This code is licensed under NYSL ver. 0.9982.
// See LICENSE.txt for details.

#include "common.h"

extern HINSTANCE g_hInstance;

// DLL Gg|Cg
int APIENTRY DllMain(HINSTANCE hInstance,
					 DWORD fdwReason,
					 LPVOID lpvReserved)
{
	switch(fdwReason) {
	case DLL_PROCESS_ATTACH:
		g_hInstance = hInstance;
		MEMLEAK_CHECK();
		break;
	case DLL_PROCESS_DETACH:
		DestroyThread();
		break;
	}
	return TRUE;
}

